﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace BusyIndicator
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = Enumerable.Range(0, 50).Select(i => new DataItem(i));
        }

        bool _isAnimating;
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (this._isAnimating)
            {
                VisualStateManager.GoToState(spinner, "IsNotAnimating", false);
                this._isAnimating = false;
            }
            else
            {
                VisualStateManager.GoToState(spinner, "IsAnimating", false);
                this._isAnimating = true;
            }
        }
    }

    public class DataItem : INotifyPropertyChanged
    {
        #region constructors
        public DataItem()
        {

        }

        public DataItem(int id)
        {
            this.Id = id;
            this.StringData = "StringData " + id;
            this.BoolData = (id % 3) == 0;
        }
        #endregion

        #region properties
        int _id;
        public int Id
        {
            get { return this._id; }
            set
            {
                if(this._id != value)
                {
                    this._id = value;
                    this.OnPropertyChanged("Id");
                }
            }
        }
        string _stringData;
        public string StringData
        {
            get { return this._stringData; }
            set
            {
                if (this._stringData != value)
                {
                    this._stringData = value;
                    this.OnPropertyChanged("StringData");
                }
            }
        }

        bool _boolData;
        public bool BoolData
        {
            get { return this._boolData; }
            set
            {
                if (this._boolData != value)
                {
                    this._boolData = value;
                    this.OnPropertyChanged("BoolData");
                }
            }
        }
        #endregion

        private void OnPropertyChanged(string propertyName)
        {
            this.PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangedEventHandler PropertyChanged;

    }
}
