﻿using Infragistics.Controls.Interactions.Primitives;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace BusyIndicator
{
    public class SpinnerBarsBusyAnimationPresenterExtended : SpinnerBarsBusyAnimationPresenter
    {
        public bool IsAnimating
        {
            get { return (bool)GetValue(IsAnimatingProperty); }
            set { SetValue(IsAnimatingProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsAnimating.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsAnimatingProperty =
            DependencyProperty.Register("IsAnimating", typeof(bool), typeof(SpinnerBarsBusyAnimationPresenterExtended), new PropertyMetadata(false, OnIsAnimatingChanged));

        private static void OnIsAnimatingChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            var presenter = (SpinnerBarsBusyAnimationPresenterExtended)d;
            if ((bool)e.NewValue)
            {
                VisualStateManager.GoToState(presenter, "IsAnimating", false);
            }
            else
            {
                VisualStateManager.GoToState(presenter, "IsNotAnimating", false);
            }
        }

    }
}
